<?php

/**
 * libro_bancos actions.
 *
 * @package    controlComisiones
 * @subpackage libro_bancos
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class libro_bancosActions extends sfActions {

    /**
     * Executes list action
     * 	
     * Filtros nuevos de fecha y numeros - 20150514
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' order by tab0.fecha, tab0.id_proyecto, tab0.doc_siif, tab0.no_resolucion, tab0.reembolso ';
        }


        /*
         * Manejo de errores
         */
        try {

            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];


            /*
             * Variables opcionales
             */
            $whereCajaMenor = "";
            if (isset($request['id_proyecto'])) {
                $whereCajaMenor = " AND tab0.id_proyecto = " . $request['id_proyecto'];
            }
            $whereComisionado = "";
            if (isset($request['id_tercero'])) {
                $whereComisionado = " AND tab0.id_tercero = " . $request['id_tercero'];
            }
            $whereNoResolucion = "";
            if (isset($request['no_resolucion'])) {
                $whereNoResolucion = " AND tab0.no_resolucion = '" . $request['no_resolucion'] . "'";
            }
            $whereNoCaja = "";
            if (isset($request['no_caja'])) {
                $whereNoCaja = " AND tab0.no_caja = " . $request['no_caja'];
            }



            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 

tab0.*,
nvl(tab2.valor,0)+nvl(tab1.deb_saldo,0)-nvl(tab1.cred_saldo,0) AS SALDO_ANTERIOR

from com_ejecucion_fecha_v tab0

LEFT JOIN (
    select tab0.id_proyecto,tab0.id_anhos,
    sum(tab0.debito) as deb_saldo,
    sum(tab0.credito) as cred_saldo
    from COM_EJECUCION_FECHA_V tab0
    where tab0.fecha < to_date('$fecha_ini','YYYY-MM-DD')
    group by tab0.id_proyecto, tab0.id_anhos
)tab1 
ON tab1.id_proyecto = tab0.id_proyecto 
and tab0.id_anhos = tab0.id_anhos

LEFT JOIN (
    select tab0.id_proyecto,tab0.id_anhos,
    sum(tab0.valor_asignado) as VALOR
    from COM_DETALLE_PRESUP tab0 
    group by tab0.id_proyecto, tab0.id_anhos
)tab2 
ON tab2.id_proyecto = tab0.id_proyecto 
and tab2.id_anhos = tab0.id_anhos

where 
tab0.id_anhos = $id_anhos 
and tab0.FECHA  BETWEEN to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')
$whereCajaMenor $whereComisionado
$whereNoResolucion $whereNoCaja                     
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 

tab0.*,
nvl(tab2.valor,0)+nvl(tab1.deb_saldo,0)-nvl(tab1.cred_saldo,0) AS SALDO_ANTERIOR

from com_ejecucion_fecha_v tab0

LEFT JOIN (
    select tab0.id_proyecto,tab0.id_anhos,
    sum(tab0.debito) as deb_saldo,
    sum(tab0.credito) as cred_saldo
    from COM_EJECUCION_FECHA_V tab0
    where tab0.fecha < to_date('$fecha_ini','YYYY-MM-DD')
    group by tab0.id_proyecto, tab0.id_anhos
)tab1 
ON tab1.id_proyecto = tab0.id_proyecto 
and tab0.id_anhos = tab0.id_anhos

LEFT JOIN (
    select tab0.id_proyecto,tab0.id_anhos,
    sum(tab0.valor_asignado) as VALOR
    from COM_DETALLE_PRESUP tab0 
    group by tab0.id_proyecto, tab0.id_anhos
)tab2 
ON tab2.id_proyecto = tab0.id_proyecto 
and tab2.id_anhos = tab0.id_anhos

where 
tab0.id_anhos = $id_anhos 
and tab0.FECHA  BETWEEN to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')
$whereCajaMenor $whereComisionado
$whereNoResolucion $whereNoCaja     
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[libro_bancos] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.codigo ';
        }


        /*
         * Manejo de errores
         */
        try {

            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];


            /*
             * Variables opcionales
             */
            $whereCajaMenor = "";
            if (isset($request['id_proyecto'])) {
                $whereCajaMenor = " AND tab0.id_proyecto = " . $request['id_proyecto'];
            }
            $whereComisionado = "";
            if (isset($request['id_tercero'])) {
                $whereComisionado = " AND tab0.id_tercero = " . $request['id_tercero'];
            }
            $whereNoResolucion = "";
            if (isset($request['no_resolucion'])) {
                $whereNoResolucion = " AND tab0.no_resolucion = '" . $request['no_resolucion'] . "'";
            }
            $whereNoCaja = "";
            if (isset($request['no_caja'])) {
                $whereNoCaja = " AND tab0.no_caja = " . $request['no_caja'];
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

'TOTALES: ' as reembolso,
sum(nvl(debito,0)) as debito,
sum(nvl(credito,0)) as credito

FROM (   

select 

tab0.*,
nvl(tab2.valor,0)+nvl(tab1.deb_saldo,0)-nvl(tab1.cred_saldo,0) AS SALDO_ANTERIOR

from com_ejecucion_fecha_v tab0

LEFT JOIN (
    select tab0.id_proyecto,tab0.id_anhos,
    sum(tab0.debito) as deb_saldo,
    sum(tab0.credito) as cred_saldo
    from COM_EJECUCION_FECHA_V tab0
    where tab0.fecha < to_date('$fecha_ini','YYYY-MM-DD')
    group by tab0.id_proyecto, tab0.id_anhos
)tab1 
ON tab1.id_proyecto = tab0.id_proyecto 
and tab0.id_anhos = tab0.id_anhos

LEFT JOIN (
    select tab0.id_proyecto,tab0.id_anhos,
    sum(tab0.valor_asignado) as VALOR
    from COM_DETALLE_PRESUP tab0 
    group by tab0.id_proyecto, tab0.id_anhos
)tab2 
ON tab2.id_proyecto = tab0.id_proyecto 
and tab2.id_anhos = tab0.id_anhos

where 
tab0.id_anhos = $id_anhos 
and tab0.FECHA  BETWEEN to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')
$whereCajaMenor $whereComisionado
$whereNoResolucion $whereNoCaja 

) 
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
